# No Cash

O No Cash é um aplicativo focado nos pais dos alunos das escolas que possuem restaurantes com os sistemas Teknisa. Para evitar que o aluno leve dinheiro para a escola, os mesmos possuem um cartão para que utilizam para resgatar os lanches e refeições. O aplicativo é utilizado pelos pais e responsáveis para recarregar este cartão. 

Pelo app também é possível visualizar o saldo atual do cartão, acompanhar o extrato de consumo do filho, disponibilizar valores diferentes para cada lanchonete ou restaurante, restringir certos tipos de alimento, dentre outras funcionalidades. 
***

## **Dependências**
  - Backend   
    -  [Composer](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [zeedhi/framework: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [zendframework/zend-mail: "~2.5"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [zeedhi/paymentplatform: "dev-odhen"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [zendframework/zend-servicemanager: "^2.7.5"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [odhen/api: "200.x-dev"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [phpunit/phpunit: "^5.7"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [pagseguro/pagseguro-php-sdk : "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [mashape/unirest-php: "~3.0.1"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [phpmailer/phpmailer: "~6.0"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)
    -  [apimatic/jsonmapper: "~1.3.0"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/composer.json)

  &nbsp;

  - Mobile
    - [grunt: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/package.json)
    - [grunt-contrib-concat: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/package.json)
    - [grunt-contrib-jshint: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/package.json)
    - [grunt-contrib-uglify: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/package.json)
    - [grunt-contrib-watch: "*"](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/package.json)




***

## **Configurações**

- **Backend**
  - [environment.xml](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/environment_teknisa.xml) - Apontamento de BD do cliente
  - [Services.xml](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/backend/services.xml) - Configurar uri base, normalmente preechido conforme exemplo abaixo:

    __*Produção*__
    ~~~XML
        <parameter key="baseUri">/backend_NomeCliente/index.php</parameter>
    ~~~
    __*Teste Cloud9*__
    ~~~XML
        <parameter key="baseUri">/backend/service/index.php</parameter>
    ~~~

    &nbsp;

- **Mobile**
  - [config.json](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/config_teknisa.json) - Configurações de endereços do projeto
  - [Utilities.js](http://gitlab.teknisa.com/odhen/nocashapp/nocash/-/blob/master/mobile/js/services/Utilities.js) - Apontamento de url base para request ao backend, normalmente preechido conforme exemplo abaixo:
  
    __*Produção*__
    ~~~js
        templateManager.updateURL(this.baseURL+'backend_NomeCliente/index.php');
    ~~~
    __*Teste Cloud9*__
    ~~~js
        templateManager.updateURL(this.baseURL+'backend/service/index.php');
    ~~~


***
## **Publicação de App**
O noCash está disponivel através do site ou aplicativos mobile. 

É possível trabalhar com o app nas lojas PlayStory ou AppStore, para isto, basta que o cliente tenha conta de desenvolvedor ativa nas lojas e nos envie as credenciais para realizarmos a publicação do app. 

### Android
  - **Requisitos**
      - [Como criar uma conta de desenvolvedor no Google Play](https://www.publiapps.com.br/blog/como-criar-conta-desenvolvedor-google-play/)
      - [PuTTY](https://the.earth.li/~sgtatham/putty/latest/w64/putty-64bit-0.77-installer.msi) - Download v0.77 x64

      
        ![Print](https://marcossouza1.zeedhi.com/workfolder/images-readme/noCash/PuTTY.png)

&nbsp;

  - **Gerar Aplicativo**
    1.  Acesse o servidor de APKs através do Putty:
        -  **Login:** root
        -  **Senha:** teknisaodhen
    2. Acesse o local dos projetos:
        - ```cd /home/teknisa/bira```
    3. Criar projeto Cordova:
        - ```cordova create [nome da paste] [endereço app na loja (com.nocash.nomecliente)] ["nome do app na loja"]```
    4. Adicionar plataforma:
        - ```cordova platform add android```
    5.  Copiar mobile do projeto para a pasta __*www*__:
        -  > Deverá ser copiado o conteúdo da pasta __*mobile*__ para dentro da pasta __*www*__. Não deverá existir o diretório __*www/mobile*__ .
    6. Gerar icones do projeto:
        - [Site para gerar Icons](https://pgicons.abiro.com/) - Gerar apenas caso necessário.
        - [pasta default](https://drive.teknisa.com/index.php/s/DdQ1Q1AQw3EHWBE) - Pasta com icones padrões do noCash
        - [Gerar config.xml](https://pgicons.abiro.com/config.xml) - Sempre gerar e atualizar linhas geradas para a plataforma no arquivo do projeto.
    7. Inserir linha abaixo na plataforma android do arquivo ``config.xml``
        - ```xml
            <preference name="android-targetSdkVersion" value="30" />
    8. Deixar apenas pasta res na raiz do projeto:
    9.  Configurar versão dos arquivos ``config.xml`` e ``package.json``
           - > Sempre incrementar de acordo com última versão publicada na loja do cliente. Na criação do projeto vem o valor default 1.0.0.
    10. Gerar APK de testes:
        - ``cordova build android``
        - Copiar __*.apk*__ gerado para ``/var/www/workfolder``
        - Baixar aquivo em sua máquina local através de  
             > http://192.168.122.82/workfolder/
        - Instalar o apk em uma aparelho android e siga o seguinte checklist
            - [x] Login 
            - [x] Acesso ao Perfil
            - [x] Alteração de Perfil
            - [x] Botões/Icones (voltar, salvar, Editar)
            - [x] Acesso as telas de restrição
            - [x] Botões/Icones (voltar, salvar, Editar, Incluir, Excluir)
            - [x] Acesso ao Cardápio
            - [x] Cadastrar Cartão
            - [x] Visualizar Cartão
            - [ ] Se possível fazer recarga de 0,01
    11. Acessar diretório `/platforms/android` e criar arquivo ``local.properties``:
        - Comando para criar arquivo 
         ~~~
             nano local.properties 
         ~~~
        - Conteudo do arquivo:
         ~~~
            sdk.dir=/usr/lib/android-sdk
         ~~~
    12. Gerar apk de release:
        - ``cordova build android --prod --release``
    13. Gerar Bundle:
        - Acesse o diretorio ``platforms/android``   
        - Execute ``./gradlew bundle``
    14. Copiar o __*.aab*__ para a raiz do projeto cordova e assinar o Bundle
        - [Arquivo de assinatura teknisa](https://drive.teknisa.com/index.php/s/pTzTuhNrnztnMKW) - Copiar para raiz do projeto cordova
        - Excute ```jarsigner -verbose -sigalg SHA1withRSA -digestalg SHA1 -keystore playStoreKeyBundle.jks app.aab playStoreKeyBundle```
            >  password: teknisa

  - **Publicar App**
    1. Acessar [google play console](https://accounts.google.com/signin/v2/identifier?service=androiddeveloper&passive=true&continue=https%3A%2F%2Fplay.google.com%2Fconsole%2Fdeveloper%2F&flowName=GlifWebSignIn&flowEntry=ServiceLogin) com a conta do cliente.
    2. Criar versão de produção
    3. Adicionar notas das alterações
    4. Enviar para analise     

&nbsp;

***
### **ios**
- **Requisitos**
    - [Como criar uma conta de desenvolvedor na Apple](https://www.easyeasyapps.net/tutoriais-como-criar-um-app/desenvolvedor-apple/)
    - [Mac In Cloud](https://drive.teknisa.com/index.php/s/RQN0OdY7vNk9pAc) - Download para acesso ao ambiente
     
&nbsp;

- **Gerando Aplicativo**
    - Zipar pasta cordova do projeto configurado no servidor de apks
        ```tar -czvf NomeDoArquivo.tar.gz NomeDaPasta```
    - Copiar para ``/var/www/workfolder``
    - Colocar no drive para baixar no mac

    1. Acessar mac pelas conexoes remotas
    2. Baixar o projeto
    3. copiar projeto para ``Desktop/Odhen-Integracoes``]
    4. Para descompactar projeto execute ```tar -xzvf NomeDoArquivo.tar.gz``` 
    5. Para adicionar plataforma ios execute ```cordova platform add ios```
        >  versão precisa ser acima de 6.0.0
        
    6. Instalar plugin da wk-webview
        - Execute ```cordova plugin add https://github.com/globules-io/cordova-plugin-ios-xhr```
        - adicionar configurações do plugin no ``config.xml``(dentro da plataforma do ios)
        ~~~xml
            <preference name="AllowUntrustedCerts"  value="true" />
            <preference name="InterceptRemoteRequests" value="all" />
            <preference name="allowFileAccessFromFileURLs" value="true" />
            <preference name="allowUniversalAccessFromFileURLs" value="true" />
        ~~~
    7. Buildar o projeto ios:
        > ``cordova build ios``
        
    8. Acessar __*.xcodeproj*__ dentro de /platforms/ios.
    9. Na aba Signing & Capabilities, colocar a conta do cliente.
        > provavelmente vai aparecer um aviso na configure de baixo, para resolver va em Build Settings, procure por "develop", na aba Signing > Code Signing Identity, troque tudo para Apple Development.

        > Volte na aba Signing & Capabilities e, se o erro ainda estever aparecendo, selecione novamente a conta do cliente na segunda configuração e ele deve desaparecer.
        
    10. Para testar, selecione [Nome do app] > [dispositivo de teste] no topo e clique no play. Sera buildado e aberto um simulador.
    11. Para gerar pacote. selecione "any ios device" no topo e va em product > archive.
    12. Na janela que abrir, selecione o app gerado e clique em distibute app
    13. Entrar na [Apple Connect](applestoreconnect.apple.com) com a conta do cliente.
    14. Colocar notas das alterações e selecioanr build gerada no mac (demora de 10 a 20 min para aparecer depois de ser feito o upload)
