<?php

namespace Service;

class MenuService {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function getProducts($CDFILIAL, $CDCAIXA){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDCAIXA' => $CDCAIXA
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PRODUCTS, $params);
    }

    public function getObservations($CDFILIAL, $CDLOJA){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDLOJA' => $CDLOJA
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_OBSERVATIONS, $params);
    }

    public function getGrupPromo($CDPRODUTO){
        $params = array(
            ':CDPRODUTO' => $CDPRODUTO
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_GRUPPROM, $params);
    }

    public function getProdGrup($CDPRODPROMOCAO, $CDGRUPROMOC, $CDFILIAL, $CDTABEPREC, $DateConverted){
        $params = array(
            ':CDPRODPROMOCAO' => $CDPRODPROMOCAO,
            ':CDGRUPROMOC' => $CDGRUPROMOC,
            ':CDFILIAL' => $CDFILIAL,
            ':CDTABEPREC' => $CDTABEPREC,
            ':DTINIVGPREC' => $DateConverted
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PRODGRUP, $params);
    }

    public function getProductsHistory($CDCLIENTE, $CDCONSUMIDOR, $CDFILIAL, $CDCAIXA) {
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':CDFILIAL' => $CDFILIAL,
            ':CDCAIXA' => $CDCAIXA
        );

        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PRODUCTS_HISTORY, $params);
    }

}