<?php

namespace Service;

class Register {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }
    
    public function registerUser($son, $userData, $CDCONSUMIDOR){
        $params = array(
            ':CDCLIENTE' => $userData['CDCLIENTE'],
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':NMCONSUMIDOR' => $son['NMCONSUMIDOR'],
            ':CDIDCONSUMID' => $son['CDIDCONSUMID'],
            ':NMLOGINCONS' => $userData['NMLOGINCONS'],
            ':CDSENHACONSMD5' => $userData['CDSENHACONSMD5'],
            ':NMRESPCONS' => $userData['NMRESPCONS'],
            ':NRCPFRESPCON' => $userData['NRCPFRESPCON'],
            ':DSEMAILCONS' => $userData['DSEMAILCONS'],
            ':NRTELECONS' => isset($userData['NRTELECONS']) ? $userData['NRTELECONS'] : null,
            ':NRCELULARCONS' => $userData['NRCELULARCONS'],
            ':DSENDECONS' => $userData['DSENDECONS'],
            ':NRENDECONS' => $userData['NRENDECONS'],
            ':DSCOMPLENDECONS' => isset($userData['DSCOMPLENDECONS']) ? $userData['DSCOMPLENDECONS'] : null,
            ':DSREFERENDECONS' => isset($userData['DSREFERENDECONS']) ? $userData['DSREFERENDECONS'] : null,
            ':NRCEPCONS' => $userData['NRCEPCONS'],
            ':CDPAIS' => $userData['CDPAIS'],
            ':SGESTADO' => $userData['SGESTADO'],
            ':CDMUNICIPIO' => $userData['CDMUNICIPIO'],
            ':NMBAIRCONS' => isset($userData['NMBAIRCONS']) ? $userData['NMBAIRCONS'] : null,
            ':CDBAIRRO' => isset($userData['CDBAIRRO']) ? $userData['CDBAIRRO'] : null, 
            ':CDTIPOCONS' => $userData['CDTIPOCONS'],
			':CDCCUSCLIE' => $userData['CDCCUSCLIE'],
    		':IDATUCONSUMI' => $userData['IDATUCONSUMI'],
    		':IDSITCONSUMI' => $userData['IDSITCONSUMI'],
    		':IDCONSUMIDOR' => $userData['IDCONSUMIDOR'],
    		':CDVENDEDOR' => $userData['CDVENDEDOR'],
    		':IDTPVENDACONS' => $userData['IDTPVENDACONS'],
    		':IDIMPCPFCUPOM' => $userData['IDIMPCPFCUPOM'],
    		':IDCADCONFLIBCON' => $userData['IDCADCONFLIBCON'],
    		':IDPERCONSPRODEX' => $userData['IDPERCONSPRODEX'],
    		':IDTPSELMANHA' => $userData['IDTPSELMANHA'],
    		':IDTPSEALMOCO' => $userData['IDTPSEALMOCO'],
    		':IDTPSELTARDE' => $userData['IDTPSELTARDE'],
    		':IDCRACHAMESTRE' => $userData['IDCRACHAMESTRE']
        );
        
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::REGISTER_USER, $params);
    }
    
    public function getConsumerByCPF($NRCPFRESPCON, $CDCLIENTE){
		$params = array(
			':NRCPFRESPCON' => $NRCPFRESPCON,
			':CDCLIENTE'	=> $CDCLIENTE
		);
		$result = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_CONSUMER_BY_CPF, $params);
		return $result;
	}
	
	 public function getConsumerById($CDIDCONSUMID, $CDCLIENTE){
		$params = array(
			':CDIDCONSUMID' => $CDIDCONSUMID,
			':CDCLIENTE'	=> $CDCLIENTE
		);
		$result = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_CONSUMER_BY_ID, $params);
		return $result;
	}
	
	public function getConsumerByLogin($NMLOGINCONS, $CDCLIENTE){
		$params = array(
			':NMLOGINCONS' => $NMLOGINCONS,
			':CDCLIENTE' => $CDCLIENTE
		);
		$result = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_CONSUMER_BY_LOGIN, $params);
		return $result;
	}
	
	public function getCDTIPOCONS($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		$CDTIPOCONS = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_TIPO_CONS, $params);
		if(empty($CDTIPOCONS['CDTIPOCONS'])) {
			throw new \Exception("A filial não tem tipo de consumidor padrão parametrizado.");
		}
		return $CDTIPOCONS['CDTIPOCONS'];
	}
	
	public function getCDCCUSCLIE($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		$CDCCUSCLIE = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_CUS_CLIE, $params);
		if(empty($CDCCUSCLIE['CDCCUSCLIE'])) {
			throw new \Exception("A filial não tem centro custo padrão parametrizado.");
		}
		return $CDCCUSCLIE['CDCCUSCLIE'];
	}

}