<?php
namespace Util;

use Doctrine\ORM\EntityManager;

use Zeedhi\Framework\DTO\Request;

class PreDispatcher extends \Zeedhi\Framework\Events\PreDispatch\Listener {

    const authRoutes = array(
        "/LoginRepository",
        "/TestConnection",
        "/ClientsRepository",
        "/ForgotPasswordRepository",
        "/UpdatePasswordRepo",
        "/LogoffRepository",
        "/SetPasswordRepository",
        "/ReloadRepository",
        "/StatesRepository",
        "/CitiesRepository",
        "/NeighbourhoodsRepository",
        "/RegisterUserRepository",
        "/RunSalesEmailService"
    );

    private $entityManager;
    private $sessionService;

    public function __construct(EntityManager $entityManager, \Util\SessionHandler $sessionService){
        $this->entityManager = $entityManager;
        $this->sessionService = $sessionService;
    }

    public function preDispatch(Request $request) {
        $route = $request->getRoutePath();
        $consumerId = $this->sessionService->getConsumerId();
        /*if ($consumerId == NULL && self::isNotAuthRoute($route)){
            throw new \Exception("Not Authenticated", 1);
        }*/
    }

    private function isNotAuthRoute($route) {
        return !in_array($route, self::authRoutes);
    }
}
