<?php
namespace Util;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class Util extends \Zeedhi\Framework\Controller\Simple {

    protected $instanceManager;
    protected $entityManager;
    protected $snackMessage;

    public function __construct(\Zeedhi\Framework\DependencyInjection\InstanceManager $instanceManager , \Util\SnackMessage $snackMessage, \Doctrine\ORM\EntityManager $entityManager, \Service\SMTP $SMTPService){
        $this->instanceManager = $instanceManager;
        $this->snackMessage    = $snackMessage;
        $this->entityManager   = $entityManager;
        $this->SMTPService = $SMTPService;
    }

    public function testConnection(Request\Filter $request, Response $response){
        try{
            $params = $request->getFilterCriteria()->getConditions();

            $version = null;

            if(isset($params[0]['value'])){
                $version = $params[0]['value'];    
            }

            if($version === '6.61'){
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('TestConnection', array(array())));
            } else{
                throw new \Exception("Esta versão está obsoleta. Favor atualizar o aplicativo na loja para continuar.");
            }

        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public static function encrypt($text, $salt = 'setforms'){
          return md5('odhen'.$text.'7833');
    }

    public static function decrypt($text, $salt = 'setforms'){
        return trim(
            mcrypt_decrypt(
                MCRYPT_RIJNDAEL_256,
                $salt,
                base64_decode($text),
                MCRYPT_MODE_ECB,
                mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
            )
        );
    }

    public function submitForm(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $assunto      = $params[0]['value'];
            $email        = $params[1]['value'];
            $telefone     = $params[2]['value'];
            $message      = $params[3]['value'];
            $CDCLIENTE    = $params[4]['value'];
            $CDCONSUMIDOR = $params[5]['value'];

            $appUrl         = $params[6]['value'];
            $logoEmail      = $params[7]['value'];
            $logoEmailInfo  = array(
                'appUrl'    => $appUrl,
                'logoEmail' => $logoEmail
            );

            $params = array(
                ':CDCLIENTE' => $CDCLIENTE,
                ':CDCONSUMIDOR' => $CDCONSUMIDOR
            );
            $consumerDetails = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CONSUMER_DETAILS, $params);

            $sonsParams = array(
                ':CDCLIENTE' => $CDCLIENTE,
                ':NRCPFRESPCON' => $consumerDetails[0]['NRCPFRESPCON']
            );
            $sons = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CONSUMER_SONS, $sonsParams);
            $sonsData = '<br>';
            foreach ($sons as $key => $son) {
                $sonsData = $sonsData . $son['NMCONSUMIDOR'] . ' - ' . $son['CDCONSUMIDOR'] . '<br>';
            }
            $sonsData = substr($sonsData, 0, -4);
            $clientName = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CLIENT_NAME, $params);
            $emailFilial = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_FILIAL_BY_CLIENT, $params);

            if (empty($emailFilial['DSEMAILCLUSO'])){
                $SMTP = $this->SMTPService->getSMTP();
                $emailFilial['DSEMAILCLUSO'] = $SMTP[0]['EMAILFALECONOSCO'];
            }

            $subject  = 'Mensagem Fale Conosco';
            $sender = 'No Cash';
            $content =
                '<p><b>CLIENTE:</b> '.$consumerDetails[0]['CDCLIENTE'].' - '.$clientName[0]['NMFANTCLIE'].'<br>'.
                '<b>RESPONSÁVEL:</b> '.$consumerDetails[0]['NMRESPCONS'].' <br>'.
                '<b>CPF: </b>'.$consumerDetails[0]['NRCPFRESPCON'].'<br>'.
                '<b>E-MAIL: </b>'.(!empty($email) ? $email : $consumerDetails[0]['DSEMAILCONS']).'<br>'.
                '<b>TELEFONE: </b>'.(!empty($telefone) ? $telefone : $consumerDetails[0]['NRTELECONS']).'</p>'.
                '<p><b>CONSUMIDOR:</b> '.$sonsData.'<br>'.'</p>'.
                '<p><b>ASSUNTO: </b>'.$assunto.'<br>'.
                '<b>MENSAGEM: </b>'.$message.'</p>'
            ;
            $this->SMTPService->sendEmail("No Cash", $emailFilial['DSEMAILCLUSO'], $sender, $subject, $content, $logoEmailInfo);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('SpeakToUsRepository', array(array())));

        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function newCode($counterName, $size ){
        $nrseq = null;
        $connection = $this->entityManager->getConnection();
        $storedProcedure = new StoredProcedure($connection, 'NOVO_CODIGO');
        $storedProcedure->addParam(new Param('P_CONTADOR', Param::PARAM_INPUT, $counterName, Param::PARAM_TYPE_STR, strlen($counterName)));
        $storedProcedure->addParam(new Param('P_SEQUENCIAL', Param::PARAM_OUTPUT, $nrseq, Param::PARAM_TYPE_INT, 20));
        $result = $storedProcedure->execute();
        
        return substr($result['P_SEQUENCIAL'], strlen($result['P_SEQUENCIAL'])-$size);
    }

    public function indexArray($array, $idxInitial, $idxFinal){
        $newArray = array();
        for($idx=$idxInitial; $idx<$idxFinal; $idx++){
            array_push($newArray, $array[$idx]);
        }
        return $newArray;
    }

    public function formatDate($date){
        //Formata o dia e o mes com dois algarismos e retorna a data no formato brasileiro
        $date = explode("/",$date);
        return str_pad($date[0],2,"0",STR_PAD_LEFT) .'/'.str_pad($date[1],2,"0",STR_PAD_LEFT).'/'.$date[2];
    }

    public function logVND($NRTRANSACAO, $CDCLIENTE, $CDCONSUMIDOR, $message){
        try {
            $params = array(
                ':NMTABELAVND' => 'CRED_NOCASH',
                ':NMRESPOPERVND' => $NRTRANSACAO,
                ':CDPESQITEMVND' => $CDCLIENTE.'-'.$CDCONSUMIDOR,
                ':CDCONSUMIDOR' => $CDCONSUMIDOR,
                ':DSOPERACAOVND' => $message,
                ':IDTIPOOPERVND' => '2',
                ':NRORG' => 1,
                ':IDATIVO' => 'S'
            );
            $this->entityManager->getConnection()->executeQuery(\Util\Query::INSERT_CRED_LOG, $params);
        } catch (\Exception $e){
            // Do nothing.
        }
    }

    public function getXMLParameter($key) {
        return $this->instanceManager->getParameter($key);
    }

    public function getRechargeFamilyName($CDFAMILISALD){
        $params = array(
            ':CDFAMILISALD' => $CDFAMILISALD
        );

        $familyName = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_RECHARGE_FAMILY_NAME, $params);

        return $familyName;
    }

    public function saveNotification($NRNOTIFICAAPP, $CDCLIENTENOTIFAPP, $CDCONSUMINOTIFAPP, $CDTIPONOTIFICAAPP, $DSNOTIFICAAPP) {
        $params = array(
            ':NRNOTIFICAAPP' => $NRNOTIFICAAPP,
            ':CDCLIENTENOTIFAPP' => $CDCLIENTENOTIFAPP,
            ':CDCONSUMINOTIFAPP' => $CDCONSUMINOTIFAPP,
            ':CDTIPONOTIFICAAPP' => $CDTIPONOTIFICAAPP,
            ':DSNOTIFICAAPP' => $DSNOTIFICAAPP
        );
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::SAVE_NOTIFICATION, $params);
    }

}