<?php
namespace Zeedhi\PaymentPlatform;

class AddressTest extends \PHPUnit_Framework_TestCase {

	/** @var Address */
	protected $address;
	/** @var String */
	protected $street = "Rua Pernambuco"; 
	/** @var String */
	protected $number = "1000"; 
	/** @var String */
	protected $complement = "Cj 102"; 
	/** @var String */
	protected $neighborhood = "Savassi"; 
	/** @var String */
	protected $city = "Belo Horizonte"; 
	/** @var String */
	protected $state = "Minas Gerais";
	/** @var String */
	protected $zipCode = "00000-001"; 
	/** @var String */
	protected $country = "BR";

	public function setUp(){
		$this->address = new Address($this->street, $this->number, $this->complement, $this->neighborhood, $this->city, $this->state, $this->zipCode, $this->country);
	}

	public function testGetStreet(){
        $this->assertEquals($this->street, $this->address->getStreet());
    }
	
	public function testGetNumber(){
        $this->assertEquals($this->number, $this->address->getNumber());
    }
	
	public function testGetComplement(){
        $this->assertEquals($this->complement, $this->address->getComplement());
    }
	
	public function testGetNeighborhood(){
        $this->assertEquals($this->neighborhood, $this->address->getneighborhood());
    }
	
	public function testGetCity(){
        $this->assertEquals($this->city, $this->address->getCity());
    }
	
	public function testGetState(){
        $this->assertEquals($this->state, $this->address->getState());
    }
	
	public function testGetZipCode(){
        $this->assertEquals($this->zipCode, $this->address->getZipCode());
    }

	public function testGetCountry(){
        $this->assertEquals($this->country, $this->address->getCountry());
    }
}