<?php
namespace Zeedhi\PaymentPlatform\BankSlip;

use Zeedhi\PaymentPlatform\Address;

class StoreBankAccountTest extends \PHPUnit_Framework_TestCase{
    
    /** @var StoreBankAccount */
    protected $storeBankAccount;
    /** @var string */
    protected $agency = "0000";
    /** @var string */
    protected $agencyDigit = "1";
    /** @var string */
    protected $account = "000100";
    /** @var string */
    protected $accountDigit = "1";
    /** @var string */
    protected $ourNumber = "0000001";
    /** @var string */
    protected $assignorNumber = "000001";
    
    public function setUp(){
        $this->storeBankAccount = new StoreBankAccount($this->agency, $this->agencyDigit, $this->account, $this->accountDigit, $this->ourNumber, $this->assignorNumber);
    }
    
    public function testGetAgency(){
        $this->assertEquals($this->agency, $this->storeBankAccount->getAgency());
    }
    
    public function testGetAgencyDigit(){
        $this->assertEquals($this->agencyDigit, $this->storeBankAccount->getAgencyDigit());
    }
    
    public function testGetAccount(){
        $this->assertEquals($this->account, $this->storeBankAccount->getAccount());
    }
    
    public function testGetAccountDigit(){
        $this->assertEquals($this->accountDigit, $this->storeBankAccount->getAccountDigit());
    }
    
    public function testGetOurNumber(){
        $this->assertEquals($this->ourNumber, $this->storeBankAccount->getOurNumber());
    }
    
    public function testGetAssignorNumber(){
        $this->assertEquals($this->assignorNumber, $this->storeBankAccount->getAssignorNumber());
    }
}