function GraphingService(Query, ProductGroupRepository, ProductSubgroupRepository, ProductsRepository, ProductGroupNutriRepository, ProductSubgroupNutriRepository, ProductsNutriRepository){

    this.getGroupedProducts = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM){
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM);
        return ProductGroupRepository.download(query);
    };

    this.getSubgroups = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM, CDGRUPPROD){
        if (CDGRUPPROD == null) CDGRUPPROD = 'NULL';
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM)
                        .where('CDGRUPPROD').equals(CDGRUPPROD);
        return ProductSubgroupRepository.download(query);
    };

    this.getProducts = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM, CDGRUPPROD, CDSUBGRPROD){
        if (CDGRUPPROD == null) CDGRUPPROD = 'NULL';
        if (CDSUBGRPROD == null) CDSUBGRPROD = 'NULL';
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM)
                        .where('CDGRUPPROD').equals(CDGRUPPROD)
                        .where('CDSUBGRPROD').equals(CDSUBGRPROD);
        return ProductsRepository.download(query);
    };

    //----------------------------- Nutritional Vision

    this.getGroupedProductsNutri = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM){
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM);
        return ProductGroupNutriRepository.download(query);
    };

    this.getSubgroupsNutri = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM, CDGRUPPROD){
        if (CDGRUPPROD == null) CDGRUPPROD = 'NULL';
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM)
                        .where('CDGRUPPROD').equals(CDGRUPPROD);
        return ProductSubgroupNutriRepository.download(query);
    };

    this.getProductsNutri = function(CDCLIENTE, CDCONSUMIDOR, DTINI, DTFIM, CDGRUPPROD, CDSUBGRPROD){
        if (CDGRUPPROD == null) CDGRUPPROD = 'NULL';
        if (CDSUBGRPROD == null) CDSUBGRPROD = 'NULL';
        var query = Query.build()
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('DTINI').equals(DTINI)
                        .where('DTFIM').equals(DTFIM)
                        .where('CDGRUPPROD').equals(CDGRUPPROD)
                        .where('CDSUBGRPROD').equals(CDSUBGRPROD);
        return ProductsNutriRepository.download(query);
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('GraphingService', GraphingService);
});
