function RechargeService(Query, RechargeGridRepository, RechargeCardRepository, RechargeBilletRepository, BankDataRepository, BilletEmailRepository, SessionIdRepo, pagSeguroRechargeRepo, UseTermsRepository){

    this.getRechargeGrid = function(CDFILIAL, NRCPFRESPCON, CDCLIENTE){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('NRCPFRESPCON').equals(NRCPFRESPCON)
                        .where('CDCLIENTE').equals(CDCLIENTE);
        return RechargeGridRepository.download(query);
    };

    this.doCardRecharge = function (valorPedido, codigoBandeira, validadeCartao, numeroCartao, codigoSegurancaCartao, CDCLIENTE, CDCONSUMIDOR, rechargeValues, CDFILIAL, appUrl, logoEmpresa, nomeCartao){

        rechargeValues = JSON.stringify(rechargeValues);

        var query = Query.build()
                        .where('valorPedido').equals(valorPedido)
                        .where('codigoBandeira').equals(codigoBandeira)
                        .where('validadeCartao').equals(validadeCartao)
                        .where('numeroCartao').equals(numeroCartao)
                        .where('codigoSegurancaCartao').equals(codigoSegurancaCartao)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('rechargeValues').equals(rechargeValues)
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('appUrl').equals(appUrl)
                        .where('logoEmpresa').equals(logoEmpresa)
                        .where('nomeCartao').equals(nomeCartao);

        return RechargeCardRepository.download(query);
    };

    this.doBilletRecharge = function (CDFILIAL, CDCLIENTE, banco, valorPorCliente, bank, appUrl, logoEmpresa){

        consumidores = [];
        for(var i = 0; i < valorPorCliente.length - 1; i++){
            consumidores.push(valorPorCliente[i].CDCONSUMIDOR);
        }

        valorTotal = valorPorCliente[valorPorCliente.length - 1].VRSALDCONFAM;

        bank = JSON.stringify(bank);

        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(consumidores)
                        .where('banco').equals(banco)
                        .where('valor').equals(valorPorCliente)
                        .where('bank').equals(bank)
                        .where('valorTotal').equals(valorTotal)
                        .where('appUrl').equals(appUrl)
                        .where('logoEmpresa').equals(logoEmpresa);

        return RechargeBilletRepository.download(query);
    };

    this.billetEmail = function (url, CDCLIENTE, CDCONSUMIDOR){
        var query = Query.build()
                        .where('billetUrl').equals(url)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR);
        return BilletEmailRepository.download(query);
    };

    this.getBankData = function (){
        return BankDataRepository.download(Query.build());
    }

    this.getSessionId = function (flag){
        if(flag){
            return SessionIdRepo.download(Query.build());
        }else{
            return SessionIdRepo.findOne().then(function(session){
                if(session){
                    return session.session_id;
                } else{
                    return SessionIdRepo.download(Query.build());
                }
            });
        }
    }

    this.pagSeguroRecharge = function (valorPedido, cardHash, cardToken, cardNumber, CDCLIENTE, CDCONSUMIDOR, rechargeValues, CDFILIAL, appUrl, logoEmpresa){
        var query = Query.build()
                        .where('valorPedido').equals(valorPedido)
                        .where('cardHash').equals(cardHash)
                        .where('cardToken').equals(cardToken)
                        .where('cardNumber').equals(cardNumber)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('rechargeValues').equals(rechargeValues)
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('appUrl').equals(appUrl)
                        .where('logoEmpresa').equals(logoEmpresa);

        return pagSeguroRechargeRepo.download(query);
    };

    this.getPaymentTerms = function (){
        return UseTermsRepository.download(Query.build());
    }

};

Configuration(function(ContextRegister){
    ContextRegister.register('RechargeService', RechargeService);
});